Description

Because it is not always feasible to send uncompressed binary 
images an image type for encoded/compressed images could be useful.

One proposal with typical image file formats could be:

package rst.vision;

option java_outer_classname = "EncodedImageType";

/**
 * An image encoded in a certain format.
 *
 * @author Viktor Richter <vrichter@techfak.uni-bielefeld.de>
 */
message EncodedImage {

    /**
     * Identifies an image encoding format.
     */
    enum Encoding {
        BMP = 0;
        PPM = 1;
        PNG = 2;
        JPG = 3;
        JP2 = 4;
        TIFF = 5;
    }

    /**
     * The encoding used to encode an image into binary data.
     */
    required Encoding encoding = 2;

    /**
     * Holds the binary image data.
     *
     * Can be decoded using the provided encoding information.
     */
    required bytes data = 1;

}
Associated revisions
Revision cd9344d3 - 07/08/2016 11:00 AM - V. Richter

Added EncodedImage type in proto/sandbox/rst/vision/EncodedImage.proto

fixes #2536

    -  proto/sandbox/rst/vision/EncodedImage.proto: new file; EncodedImage
  type

Signed-off-by: Jan Moringen <jmoringe@techfak.uni-bielefeld.de>

History
#1 - 04/30/2016 01:56 PM - J. Moringen
- Status changed from New to Feedback
- Target version set to rsb-0.14

This is a sane design choice.

There may be another valid design: When I thought about a similar type, I considered adding an ImageDimensions or ImageFormat type describing
things like width, height, channels, … and using it for compressed and maybe at some point raw images. Of course, this information is available from 
data, but not without decoding.

What do you think?

#2 - 05/11/2016 09:46 AM - V. Richter

J. Moringen wrote:

There may be another valid design: When I thought about a similar type, I considered adding an ImageDimensions or ImageFormat type describing
things like width, height, channels, … and using it for compressed and maybe at some point raw images. Of course, this information is available
from data, but not without decoding.

I do not have a problem with the resulting redundancy when adding ImageDimension information to this type (the encoding information already is
redundant because it should be encoded in the magic number in the data field).

ImageDimension seems pretty straight forward: {{collapse(rst.vision.ImageDimension)

package rst.vision;

option java_outer_classname = "ImageDimensionType";

/**
 * The dimension of a rasterised image.
 *
 * @author Viktor Richter <vrichter@techfak.uni-bielefeld.de>
 */
message ImageDimension {
    /** 
     * The number of pixels in each row of the image.
     */
    // @unit(pixel)
    required uint32 width = 1;

    /** 
     * The number of pixels in each column of the image.
     */
    // @unit(pixel)
    required uint32 height = 2;

}

}}

What would the definition of an ImageFormat type reflect? As I understand all other information in rst/vision/Image are encoding properties and mainly
there to be able to decode the attached byte array.

#3 - 06/08/2016 09:03 PM - J. Moringen
- Target version changed from rsb-0.14 to rsb-0.15

#4 - 07/08/2016 09:25 AM - V. Richter

Is there anything I can do to further advance the inclusion of this type?

#5 - 07/08/2016 09:54 AM - J. Moringen

V. Richter wrote:

Is there anything I can do to further advance the inclusion of this type?

Can you provide one-sentence descriptions of the enum values? For example, JP2 is not immediately clear to me. Also, maybe remove BMP to not
encourage encoding uncompressed images via this type.

#6 - 07/08/2016 09:54 AM - J. Moringen
- Assignee set to J. Moringen

#7 - 07/08/2016 10:37 AM - V. Richter

I added documentation to the enum elements and removed bmp.

{{collapse(rst.vision.EncodedImage)

package rst.vision;

option java_outer_classname = "EncodedImageType";
/**
 * An image encoded in a certain format.
 *
 * @author Viktor Richter <vrichter@techfak.uni-bielefeld.de>
 */
message EncodedImage {

    /**
     * Identifies an image/file encoding format.
     */
    enum Encoding {

        /**
         * Portable Pixmap Format.
         *
         * An open uncompressed image file format.
         * @see https://en.wikipedia.org/wiki/Netpbm_format
         */
        PPM = 1;

        /**
         * Portable Network Graphics format (ISO/IEC 15948).
         *
         * An open lossless compressed image file format.
         * @see https://en.wikipedia.org/wiki/Portable_Network_Graphics
         */
        PNG = 2;

        /**
         * Also known as JPEG (ISO/IEC 10918).
         *
         * An image file format with adjustable lossy compression
         * created by the Joint Photographic Experts Group. The
         * compression is based on the discrete cosine transform.
         * @see https://en.wikipedia.org/wiki/JPEG
         */
        JPG = 3;

        /**
         * Also known as JPEG2000 (ISO/IEC 15444).
         *
         * An image file format with adjustable lossy compression
         * created by the Joint Photographic Experts Group. This
         * format superseeds JPG and can use discrete cosine transform
         * or wavelet based methods for compression.
         * @see https://en.wikipedia.org/wiki/JPEG_2000
         */
        JP2 = 4;

        /**
         * Tagged Image File Format.
         *
         * A computer file format for raster graphics developed by
         * adobe.
         * @see https://en.wikipedia.org/wiki/Tagged_Image_File_Format
         */
        TIFF = 5;
    }

    /**
     * The encoding used to encode an image into binary data.
     */
    required Encoding encoding = 2;

    /**
     * Holds the binary image data.
     *
     * Can be decoded using the provided encoding information.
     */
    required bytes data = 1;

}

}}

#8 - 07/08/2016 10:49 AM - J. Moringen

V. Richter wrote:

I added documentation to the enum elements and removed bmp.

LGTM, thanks.

#9 - 07/08/2016 11:02 AM - V. Richter
- Status changed from Feedback to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:rst-proto|cd9344d38982b1fe226559870038214665ac519b.
